//Game APIs neede by the main loop.
//Luke Lenhart, 2008
//See the MPMA Framework license for details on how this code may be used.

#include "mpma/geo/Geo.h"

namespace Game
{
    //update the world
    void Update(bool passTime=true);

    //state info
    extern std::string PLeftName;
    extern std::string PRightName;
    extern bool AmIPLeft;
    extern bool AmIPRight;
    extern int LeftScore;
    extern int RightScore;

    // -- interface for networking stuff to poke us with

    //give up control of the ball (if its state is not determined)
    void YieldInitialControl();

    //state of the world
    struct NetGameState
    {
        uint32 inControl; //what the other side thinks
        uint32 gameStage;

        GEO::Vector2 ballPos;
        GEO::Vector2 ballDir;

        float paddleLeftY;
        float paddleRightY;
    };
    const int NetGameStateSize=4+4+8+8+4+4;

    //retrieves how we see the world
    NetGameState GetNetState();

    //updates how we se ethe world - we will ignore part of this
    void UpdateNetState(const NetGameState &net);
}
