//simple geometry intersection functions.  This is not yet officially part of MPMA, due to the fact that what's here is just random scattered stuff I found useful.
//Luke Lenhart (2005-2008)
//See /docs/License.txt for details on how this code may be used.

#pragma once

#include "GeoObjects.h"

namespace GEO
{
    namespace INTERSECT
    {
        //line and plane intersection
        bool LinePlane(const Line &inLine, const Plane &inPlane, Vector3 &outPoint);
        bool LinePlane(const Line &inLine, const Plane &inPlane);

        //line and sphere
        bool LineSphere(const Line &inLine, const Sphere &inSphere, Vector3 &outPoint1, Vector3 &outPoint2);
        bool LineSphere(const Line &inLine, const Sphere &inSphere);

        bool RaySphere(const Line &inLine, const Sphere &inSphere);

        //line and axis-aligned ellipsoid
        bool LineYAlignedEllipsoid(const Line &inLine, const YAlignedEllipsoid &inEllipse, Vector3 &outPoint1, Vector3 &outPoint2);

        bool RayYAlignedEllipsoid(const Line &inLine, const YAlignedEllipsoid &inEllipse);

        //line and axis aligned 3d rectangle
        bool LineAARectoid(const Line &inLine, const AARectoid &rect, Vector3 &outPoint1, Vector3 &outNormal1, Vector3 &outPoint2, Vector3 &outNormal2);

        //line and axis aligned unbounded cylinder
        bool LineXAlignedUnboundedCylinder(const Line &inLine, const XAlignedUnboundedCylinder &inCyl, Vector3 &outPoint1, Vector3 &outPoint2);
        Vector3 NormalFromIntersection(const Vector3 &isect, const XAlignedUnboundedCylinder &inCyl);

        bool RayXAlignedUnboundedCylinder(const Line &inLine, const XAlignedUnboundedCylinder &inCyl);
    }

}; // namespace GEO
